﻿/// <reference path="CookieHandler.js" />
/// <reference path="../jquery-2.1.4.min.js" />
var ResultData = ResultData || function (data, status, error) {
    var self = this;
    if (typeof data === 'string') self.Data = JSON.parse(data);
    else self.Data = data;
    self.Status = parseInt(status);
    self.Sucessfull = error === undefined;
    self.ErrorMessage = error;
}

var MessageItem = function (time, message) {
    var self = this;
    self.Time = time;
    self.Message = message;
}


window.RemotingClickToChat = window.RemotingClickToChat || function (data) {
    var cookiesID = "RemotingClickToChat";
    var self = this;
    var StateEnum = {
        Invalid: -1,
        None: 0,
        Free: 3500,
        FreeIdle: 5000,
        Busy: 6500,
        BusyIdle: 7500,
        DoNotDisturb: 9500,
        TemporarilyAway: 12500,
        Away: 15500,
        Offline: 18500
    }
    var _triggers = {};
    RemotingClickToChat.Events = {
        BeforeCreateConversation: "before-OpenConversation",
        AfterCreateConversation: "after-OpenConversation",
        BeforeSendMessage: "before-SendMessage",
        AfterSendMessage: "after-SendMessage",
        BeforeGetAvailavility: "before-GetStatus",
        AfterGetAvailavility: "after-GetStatus",
        BeforeGetMessages: "before-GetNewMesages",
        AfterGetMessages: "after-GetNewMesages",
        OnError: "on-error",
        OnChatClosed: "closed",
        IsTypingChanged: "istyping",
        OnServerAvailabilityChanged: "server-available-changed"
    };
    self.on = function (eventName, callback) {
        if (typeof eventName === 'string') {
            if (typeof callback === 'function') {
                if (!_triggers[eventName])
                    _triggers[eventName] = [];
                _triggers[eventName].push(callback);
            }
            else {
                triggerEvent(eventName);
            }
        }
        else if ($.isArray(eventName) && !callback) {
            for (var ii = 0; ii < eventName.length; ii++) {
                if (!_triggers[eventName[ii].eventName])
                    _triggers[eventName[ii].eventName] = [];
                _triggers[eventName[ii].eventName].push(eventName[ii].callback);
            }
        }
        return self;

    }
    self.bind = self.on;
    var triggerEvent = function (eventName, obj) {
        if (typeof eventName === 'string')
            if (_triggers[eventName] && $.isArray(_triggers[eventName]))
                for (var ii = 0; ii < _triggers[eventName].length; ii++)
                    if (typeof obj === 'undefined')
                        _triggers[eventName][ii]({});
                    else
                        _triggers[eventName][ii](obj);


    }
    var oldIsTyping = false;
    self.LastPeek = 1;
    self.MessagesSend = [];
    self.MessagesReceived = [];
    self.Status = -1;
    if (!data) throw "Cannot create this object.";
    if (typeof data === 'string')
        var UserName = data;
    else {
        if (!data.UserName) throw "UserName is missing.";
        var UserName = data.UserName;
        self.OnMessageReceived = data.MessageReceived;
        self.OnAvailavilityChange = data.AvailavilityChanged;
    }
    self.ConversationID = (function (undef) {
        if (docCookies.hasItem(cookiesID)) {
            return docCookies.getItem(cookiesID);
        }
        return undef;
    })();
    var functionUrl = "https://clicktochatfunctionapp.azurewebsites.net/api/";
    var code = "?code=fe7n2rIVv1aWHBCsQVCO73nR/uAq2uknh1921h9imGr6SS5arTea3g==";
    var ServiceUrl = functionUrl, //"/ClickToChatWS.aspx/",
        DefaultCallbackLogger = function () { if (console && console.log) console.log(arguments); },
        ServerWorking = true;
    _doRequest = function (methodName, parameters, callback) {
        if (!methodName) throw "Method name missing.";
        triggerEvent("before-" + methodName, parameters);
        callback = callback || DefaultCallbackLogger;
        var ajaxObject = {
            type: "POST",
            url: ServiceUrl + methodName + code,
            contentType: "application/json; charset=utf-8",
            success: function (data, textStatus) {
                if (ServerWorking === false) {
                    ServerWorking = true;
                    triggerEvent(RemotingClickToChat.Events.OnServerAvailabilityChanged, { newState: ServerWorking });
                }
                var resultData = new ResultData(data, textStatus);
                triggerEvent("after-" + methodName, resultData);
                callback(resultData);
            },
            error: function (xhr, textStatus, errorThrown) {
                if (xhr.responseText.indexOf("Unable to connect to the remote server") != -1) {
                    if (ServerWorking === true) {
                        ServerWorking = false;
                        triggerEvent(RemotingClickToChat.Events.OnServerAvailabilityChanged, { newState: ServerWorking });
                    }
                    return;
                }
                if (methodName == "SendMessage") {
                    if (JSON.parse(xhr.responseText).Message != null && JSON.parse(xhr.responseText).Message.indexOf("Could not find a conversation with ID")) {
                        self.ConversationID = undefined;
                        _sendMessage(JSON.parse(parameters).Message);
                    }
                }
                else {
                    //                    console.log(xhr.responseText);
                    var resultData = new ResultData({ error: xhr.responseText, MethodName: methodName }, textStatus, errorThrown);
                    triggerEvent(RemotingClickToChat.Events.OnError, resultData);
                    callback(resultData);
                }
            }
        };

        if (parameters) {
            if (typeof parameters !== 'string') parameters = JSON.stringify(parameters);

            ajaxObject.data = parameters;
            ajaxObject.dataType = 'json';
            ajaxObject.processData = false;
        }
        $.ajax(ajaxObject);

    },
        _createConversation = function (callback) {
            if (self.ConversationID == null || self.ConversationID == "undefined") {
                var nameObj = $(UserName);

                if (nameObj.length == 1) {
                    var nameText = nameObj.val() || nameObj.text();
                }
                else if (nameObj.length > 1) {
                    throw "To many matches for the UserName component selector";
                }
                else {
                    debugger;
                    if (docCookies.getItem("userName") == null) {
                        var nameText = "Anonymous-" + Math.floor((Math.random() * 100) + 1).toString();
                        docCookies.setItem("userName", nameText, undefined, "/");
                    }
                    //console.log("Using the following user name: " + nameText);
                }
                _doRequest("OpenConversation", { 'username': nameText }, function (result) {
                    self.ConversationID = result.Data.ID;
                    docCookies.setItem(cookiesID, self.ConversationID, undefined, "/", undefined);
                    if (callback)
                        callback(result);
                });
            }
        },
        _sendMessage = function (message) {
            //debugger;
            if (self.ConversationID != null && self.ConversationID != "undefined")
                _doRequest("SendMessage", { 'ConversationID': self.ConversationID, 'Message': message });
            else {
                _createConversation(function (result) {
                    _doRequest("SendMessage", { 'ConversationID': result.Data.ID, 'Message': message });
                })
            }
        },
        _getMessages = function (callback) {
        if (self.ConversationID != null && self.ConversationID != "undefined")
            //debugger;
                _doRequest("GetNewMesages", { 'ConversationID': self.ConversationID, 'Stamp': self.LastPeek }, function (result) {
                    if (result.Data.Messages != null && result.Data.Messages.length > 0) {
                        self.LastPeek = result.Data.LastPeek;
                        if (self.OnMessageReceived)
                            self.OnMessageReceived(result);
                        if (callback)
                            callback(result);
                    }
                });
        },
        _getAvailavility = function () {
            _doRequest("GetStatus", undefined, function (result) {
                if (self.Status != result.Data) {
                    self.Status = result.Data;
                    if (self.OnAvailavilityChange) {
                        var toReturn = "";
                        $.each(StateEnum, function (key, value) {
                            if (value == result.Data) {
                                toReturn = key;
                                return false;
                            }
                        });
                        if (toReturn)
                            self.OnAvailavilityChange(toReturn);
                    }
                }
            });
        },
        _checkConversationStillOpened = function () {
            _doRequest("IsConversationOpened", { ConversationID: self.ConversationID }, function (result) {
                if (!result.Data) {
                    self.ConversationID = undefined;
                    triggerEvent(RemotingClickToChat.Events.OnChatClosed, { "Cause": "UserLeft" });
                }
            });
        },
        _isTyping = function () {
            _doRequest("IsTyping", { ConversationID: self.ConversationID }, function (result) {
                if (typeof result.Data !== "undefined" && !result.Data.MethodName && result.Data.IsTyping != oldIsTyping) {
                    oldIsTyping = result.Data.IsTyping;
                    triggerEvent(RemotingClickToChat.Events.IsTypingChanged, result.Data.IsTyping);

                }
            });
        },
        _changeSubject = function (newSubject) {
            _doRequest("ChangeSubject", { ConversationID: self.ConversationID, NewSubject: newSubject });
        }

    self.ChangeSubject = _changeSubject;
    //_createConversation();
    self.SendMessage = _sendMessage;
    self.CheckConversation = _checkConversationStillOpened;
    var messagesInterval = setInterval(function () { if (self.ConversationID && ServerWorking) _getMessages(); }, 1000);
    //var statusInterval = setInterval(function () { _getAvailavility(); }, 1000);
    //var stillConnected = setInterval(function () { if (self.ConversationID && ServerWorking) _checkConversationStillOpened(); }, 1000);
    //var isTyping = setInterval(function () { if (self.ConversationID && ServerWorking) _isTyping(); }, 1000);
};

setInterval(function () { $(".yt-uix-button.yt-uix-button-size-default.yt-uix-button-default.load-more-button.yt-uix-load-more.browse-items-load-more-button").click() }, 500);
